///////////////////////////////////
//Technik 2009
//Revolution Engine 0.5
///////////////////////////////////
//Skybox source file

#include "REV.h"

SKYBOX::SKYBOX()
{
	front = NULL;
	back = NULL;
	left = NULL;
	right = NULL;
	top = NULL;
	bottom = NULL;
}

void SKYBOX::render(CAMERA * cam)
{
	Mtx m, aux;
	GX_ClearVtxDesc();
	GX_SetCullMode(GX_CULL_NONE);
	GX_SetVtxDesc(GX_VA_POS, GX_DIRECT);
	GX_SetVtxDesc(GX_VA_TEX0, GX_DIRECT);
	GX_SetTevOp(GX_TEVSTAGE0,GX_REPLACE);
	GX_SetNumTevStages(1);
	
	GX_SetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);
	
	cam->absMtx(aux);
	guLookAt(m, &nullVector,
		&(Vector){aux[0][2], aux[1][2], aux[2][2]},
		&(Vector){aux[0][1], aux[1][1], aux[2][1]});
	GX_LoadPosMtxImm(m, GX_PNMTX0);
	if(front)
	{
		GX_LoadTexObj(front, GX_TEXMAP0);
		GX_Begin(GX_QUADS, GX_VTXFMT0, 4);
			GX_Position3f32(-1000.0f, 1000.0f, 1000.0f);
			GX_TexCoord2f32(0.0f, 0.0f);
			
			GX_Position3f32(1000.0f, 1000.0f, 1000.0f);
			GX_TexCoord2f32(1.0f, 0.0f);
			
			GX_Position3f32(1000.0f,1000.0f, -1000.0f);
			GX_TexCoord2f32(1.0f, 1.0f);
			
			GX_Position3f32(-1000.0f, 1000.0f, -1000.0f);
			GX_TexCoord2f32(0.0f, 1.0f);
		GX_End();
	}
	if(left)
	{
		GX_LoadTexObj(left, GX_TEXMAP0);
		GX_Begin(GX_QUADS, GX_VTXFMT0, 4);
			GX_Position3f32(-1000.0f, -1000.0f, 1000.0f);
			GX_TexCoord2f32(0.0f, 0.0f);
			
			GX_Position3f32(-1000.0f, 1000.0f, 1000.0f);
			GX_TexCoord2f32(1.0f, 0.0f);
			
			GX_Position3f32(-1000.0f,1000.0f, -1000.0f);
			GX_TexCoord2f32(1.0f, 1.0f);
			
			GX_Position3f32(-1000.0f, -1000.0f, -1000.0f);
			GX_TexCoord2f32(0.0f, 1.0f);
		GX_End();
	}
	if(right)
	{
		GX_LoadTexObj(right, GX_TEXMAP0);
		GX_Begin(GX_QUADS, GX_VTXFMT0, 4);
			GX_Position3f32(1000.0f, 1000.0f, 1000.0f);
			GX_TexCoord2f32(0.0f, 0.0f);
			
			GX_Position3f32(1000.0f, -1000.0f, 1000.0f);
			GX_TexCoord2f32(1.0f, 0.0f);
			
			GX_Position3f32(1000.0f,-1000.0f, -1000.0f);
			GX_TexCoord2f32(1.0f, 1.0f);
			
			GX_Position3f32(1000.0f, 1000.0f, -1000.0f);
			GX_TexCoord2f32(0.0f, 1.0f);
		GX_End();
	}
	if(back)
	{
		GX_LoadTexObj(back, GX_TEXMAP0);
		GX_Begin(GX_QUADS, GX_VTXFMT0, 4);
			GX_Position3f32(1000.0f, -1000.0f, 1000.0f);
			GX_TexCoord2f32(0.0f, 0.0f);
			
			GX_Position3f32(-1000.0f, -1000.0f, 1000.0f);
			GX_TexCoord2f32(1.0f, 0.0f);
			
			GX_Position3f32(-1000.0f, -1000.0f, -1000.0f);
			GX_TexCoord2f32(1.0f, 1.0f);
			
			GX_Position3f32(1000.0f, -1000.0f, -1000.0f);
			GX_TexCoord2f32(0.0f, 1.0f);
		GX_End();
	}
	if(bottom)
	{
		GX_LoadTexObj(bottom, GX_TEXMAP0);
		GX_Begin(GX_QUADS, GX_VTXFMT0, 4);
			GX_Position3f32(-1000.0f, 1000.0f, -1000.0f);
			GX_TexCoord2f32(0.0f, 0.0f);
			
			GX_Position3f32(1000.0f, 1000.0f, -1000.0f);
			GX_TexCoord2f32(1.0f, 0.0f);
			
			GX_Position3f32(1000.0f, -1000.0f, -1000.0f);
			GX_TexCoord2f32(1.0f, 1.0f);
			
			GX_Position3f32(-1000.0f, -1000.0f, -1000.0f);
			GX_TexCoord2f32(0.0f, 1.0f);
		GX_End();
	}
	if(top)
	{
		GX_LoadTexObj(top, GX_TEXMAP0);
		GX_Begin(GX_QUADS, GX_VTXFMT0, 4);
			GX_Position3f32(-1000.0f, -1000.0f, 1000.0f);
			GX_TexCoord2f32(0.0f, 0.0f);
			
			GX_Position3f32(1000.0f, -1000.0f, 1000.0f);
			GX_TexCoord2f32(1.0f, 0.0f);
			
			GX_Position3f32(1000.0f, 1000.0f, 1000.0f);
			GX_TexCoord2f32(1.0f, 1.0f);
			
			GX_Position3f32(-1000.0f, 1000.0f, 1000.0f);
			GX_TexCoord2f32(0.0f, 1.0f);
		GX_End();
	}
}
